﻿using System;

namespace CryptoCalc
{
    public class DB_Classes
    {
        public class Transaction
        {
            public Transaction() { }
            public Transaction(string _currency, float _amount, string _type, string _feeCurrency, float _feeAmount)
            {
                Year = DateTime.Now.Year;
                Month = DateTime.Now.Month;
                Day = DateTime.Now.Day;
                Hour = DateTime.Now.Hour;
                Minute = DateTime.Now.Minute;
                Second = DateTime.Now.Second;
                DateTimeString = DateTime.Now.ToString();
                Currency = _currency;
                Amount = _amount;
                TransactionType = _type;
                FeeCurrency = _feeCurrency;
                FeeAmount = _feeAmount;
                Service = "";
                Comment = "";
            }

            public int Index { get; set; }
            public int Year { get; set; }
            public int Month { get; set; }
            public int Day { get; set; }
            public int Hour { get; set; }
            public int Minute { get; set; }
            public int Second { get; set; }
            public string DateTimeString { get; set; }
            public string Currency { get; set; }
            public float Amount { get; set; }
            public string TransactionType { get; set; }
            public string FeeCurrency { get; set; }
            public float FeeAmount { get; set; }
            public string Service { get; set; }
            public string Comment { get; set; }

            //Functions
            public string FullInfo => $"{ Index.ToString() } { DateTimeString } { Currency } { Amount } { TransactionType }";

        }
        public class RawData
        {
            public RawData(){}
            public RawData(string _currency, float _amount, string _type)
            {
                Date_Year = DateTime.Now.Year;
                Date_Month = DateTime.Now.Month;
                Date_Day = DateTime.Now.Day;
                Time_Hour = DateTime.Now.Hour;
                Time_Minute = DateTime.Now.Minute;
                Time_Second = DateTime.Now.Second;
                DateTimeString = DateTime.Now.ToString();
                CryptoCurrency = _currency;
                Amount = _amount;
                TransactionType = _type;
                Service = "";
                Comment = "";
            }

            public int Index { get; set; }
            public int Date_Year { get; set; }
            public int Date_Month { get; set; }
            public int Date_Day { get; set; }
            public int Time_Hour { get; set; }
            public int Time_Minute { get; set; }
            public int Time_Second { get; set; }
            public string DateTimeString { get; set; }
            public string CryptoCurrency { get; set; }
            public float Amount { get; set; }
            public string TransactionType { get; set; }
            public string Service { get; set; }
            public string Comment { get; set; }
            public string FullInfo => $"{ Index.ToString() } { DateTimeString } { CryptoCurrency } { Amount } { TransactionType }";

        }
    }
}
