﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Diagnostics;
using static CryptoCalc.DB_Classes;

namespace CryptoCalc
{
    public partial class MainWindow : Window
    {
        private readonly Random rand = new();
        private List<RawData> transactions = new();
        
        public MainWindow()
        {
            InitializeComponent();
        }

        private void saveButton_Click(object sender, RoutedEventArgs e)
        {
            DBInteraction.SaveTransaction(DummyTransaction());
        }
        private void saveButtonFromInput_Click(object sender, RoutedEventArgs e)
        {
            DBInteraction.SaveTransaction(new RawData(inputCurrency.Text, Convert.ToSingle(inputAmount.Text), inputType.Text));
        }

        private void readButton_click(object sender, RoutedEventArgs e)
        {
            transactions = DBInteraction.LoadTransactions();
            foreach (RawData x in transactions)
            {
                Debug.WriteLine($"{x.DateTimeString} *** {x.CryptoCurrency} - {x.Amount}");
            }
        }
        private void searchButton_Click(object sender, RoutedEventArgs e)
        {
            transactions = DBInteraction.LoadTransactionsOfCurrency(currencyText.Text);
            transactionsFoundListBox.Items.Clear();
            foreach (RawData x in transactions)
            {
                transactionsFoundListBox.Items.Add(x.FullInfo);
            }
        }
        private RawData DummyTransaction()
        {
            RawData t = new();
            t.Date_Year = DateTime.Now.Year;
            t.Date_Month = DateTime.Now.Month;
            t.Date_Day = DateTime.Now.Day;
            t.Time_Hour = DateTime.Now.Hour;
            t.Time_Minute = DateTime.Now.Minute;
            t.Time_Second = DateTime.Now.Second;
            t.DateTimeString = DateTime.Now.ToString();
            t.CryptoCurrency = "SOL";
            t.Amount = Convert.ToSingle(30 * rand.NextDouble());
            t.TransactionType = "DEPOSIT";
            t.Service = "Firi";
            t.Comment = "Test";
            return t;
        }
    }
}
